<%--
 $Id: showSchedule_common.jsp 11564 2015-06-25 06:37:10Z nie $
--%>

<%@ page pageEncoding="UTF-8" import="java.util.*" errorPage="error.jsp" %>
<fmt:setBundle basename="jfcapp"/>

<%!
  public final boolean isNotBlank(String s) {
    if (s != null && s.length() > 0) {
      return true;
    }
    return false;
  }

  public final Calendar createCalendar(String date) {
    String[] formats = {
      "yyyy-MM-dd",
      "yyyy-MM"
    };
    java.util.Date _date = jp.jasminesoft.util.DateTimeUtil.getDateWithFormat(date, formats);
    if (_date == null)
      return null;
    Calendar cal = Calendar.getInstance();
    cal.setTime(_date);
    return cal;
  }

  public final int getProperYoubi(String date) {
    Calendar cal = createCalendar(date);
    if (cal != null)
      return cal.get(java.util.Calendar.DAY_OF_WEEK);
    return -1;
  }

  public final boolean isSunday(String date) {
    int youbi = getProperYoubi(date);
    if (youbi == Calendar.SUNDAY)
      return true;
    return false;
  }

  public final boolean isSaturday(String date) {
    int youbi = getProperYoubi(date);
    if (youbi == Calendar.SATURDAY)
      return true;
    return false;
  }

  public final boolean isHoliday(String holiday) {
    if (holiday != null && holiday.trim().length() > 0) {
      return true;
    }
    return false;
  }

  public final String getCaption(jp.jasminesoft.jfc.model.jcalendar_lp.JcalendarLp jcalendar_lp,
                           int type,
						   String locale) {
    jp.jasminesoft.jfc.model.jcalendar_lp.Item[] items = jcalendar_lp.getItem();
    String caption = "";
    java.text.SimpleDateFormat df = 
      (java.text.SimpleDateFormat)java.text.DateFormat.getDateTimeInstance();
    if (type == Calendar.MONTH || type == Calendar.WEEK_OF_MONTH) {
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.format.yyyyM", locale);
      df.applyPattern(rkey);
    } else {
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.format.yyyyMd", locale);
      df.applyPattern(rkey);
    } 
    for (int i=0; i<items.length; i++) {
      if (type == Calendar.MONTH) {
        if (!"7".equals(items[i].getPosition())) {
          continue;
        }
      }
      java.util.Date _date = createCalendar(items[i].getDate()).getTime();
      caption = df.format(_date);
      break;
    }
    return caption;
  }

  public final String createEscapeString(String s) {
    s = org.apache.commons.lang3.StringEscapeUtils.escapeHtml4(s);
    s = jp.jasminesoft.util.StringUtil.replaceAll(s, "\n", "<br/>"); // \u000a
    return s;
  }

  public final String createCalInfoBox(jp.jasminesoft.jfc.model.jcalendar_lp.Calendaritem citem, String locale) {
    StringBuilder sb = new StringBuilder();
    sb.append("<table class=\"schedule_header\">");

    String modelname = citem.getModelname();
    if (modelname != null && modelname.length() > 0) {
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.label.modelname", locale);
      sb.append("<tr>");
      sb.append("<th class=\"schedule_hide\">");
      sb.append(rkey);
      sb.append("</th>");
      sb.append("<td class=\"schedule_normal1\">");
      sb.append(modelname);
      sb.append("</td>");
      sb.append("</tr>");
    }

    jp.jasminesoft.jfc.model.jcalendar_lp.Starthour __starthour =
      citem.getStarthour();
    jp.jasminesoft.jfc.model.jcalendar_lp.Startminute __startminute =
      citem.getStartminute();

    if (__starthour != null && __starthour.getContent() != null) {   
      String cnt1 = createEscapeString(__starthour.getContent());
      String cnt2 = null;
      if (__startminute == null || __startminute.getId() == 0) {
        cnt2 = "00";
      } else {
        cnt2 = createEscapeString(__startminute.getContent());
      }
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.label.startdate", locale);
      sb.append("<tr>");
      sb.append("<th class=\"schedule_hide\">");
      sb.append(rkey);
      sb.append("</th>");
      sb.append("<td class=\"schedule_normal1\">");
      sb.append(cnt1 + ":" + cnt2);
      sb.append("</td>");
      sb.append("</tr>");
    }

    jp.jasminesoft.jfc.model.jcalendar_lp.Endhour __endhour =
      citem.getEndhour();
    jp.jasminesoft.jfc.model.jcalendar_lp.Endminute __endminute =
      citem.getEndminute();
    if (__endhour != null && __endhour.getContent() != null) {   
      String cnt1 = createEscapeString(__endhour.getContent());
      String cnt2 = null;
      if (__endminute == null || __endminute.getId() == 0) {
        cnt2 = "00";
      } else {
        cnt2 = createEscapeString(__endminute.getContent());
      }
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.label.enddate", locale);
      sb.append("<tr>");
      sb.append("<th class=\"schedule_hide\">");
      sb.append(rkey);
      sb.append("</th>");
      sb.append("<td class=\"schedule_normal1\">");
      sb.append(cnt1 + ":" + cnt2);
      sb.append("</td>");
      sb.append("</tr>");
    }

    String __title = citem.getTitle();
    if (__title != null && __title.length() > 0) {
      String cnt = createEscapeString(__title);
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.label.title", locale);
      sb.append("<tr>");
      sb.append("<th class=\"schedule_hide\">");
	  sb.append(rkey);
      sb.append("</th>");
      sb.append("<td class=\"schedule_normal1\">");
      sb.append(cnt);
      sb.append("</td>");
      sb.append("</tr>");
    }

    String __place = citem.getPlace();
    if (__place != null && __place.length() > 0) {
      String cnt = createEscapeString(__place);
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.label.place", locale);
      sb.append("<tr>");
      sb.append("<th class=\"schedule_hide\">");
      sb.append(rkey);
      sb.append("</th>");
      sb.append("<td class=\"schedule_normal1\">");
      sb.append(cnt);
      sb.append("</td>");
      sb.append("</tr>");
    }

    String __staff = citem.getStaff();
    if (__staff != null && __staff.length() > 0) {
      String cnt = createEscapeString(__staff);
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.label.staff", locale);
      sb.append("<tr>");
      sb.append("<th class=\"schedule_hide\">");
      sb.append(rkey);
      sb.append("</th>");
      sb.append("<td class=\"schedule_normal1\">");
      sb.append(cnt);
      sb.append("</td>");
      sb.append("</tr>");
    }

    String __note = citem.getNote();
    if (__note != null && __note.length() > 0) {
      String cnt = createEscapeString(__note);
      String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.label.note", locale);
      sb.append("<tr>");
      sb.append("<th class=\"schedule_hide\">");
      sb.append(rkey);
      sb.append("</th>");
      sb.append("<td class=\"schedule_normal1\">");
      sb.append(cnt);
      sb.append("</td>");
      sb.append("</tr>");
    }

    sb.append("</table>");
    return sb.toString();
  }

  public final boolean isInclude(String staff, String input) {
    if (staff == null || input == null)
      return false;

    boolean ret = false;
    String[] stokens = input.split(",");
    if (stokens != null && stokens.length > 0) {
      for (int i=0; i<stokens.length; i++) {
        if (staff.equals(stokens[i])) {
          ret = true;
          break;
        }
      }
    }
    return ret;
  }

  public final String[] getStaffArray(jp.jasminesoft.jfc.model.jcalendar_lp.Item[] items) {
    Set staffSet = new TreeSet();
    for (int i=0; i<items.length; i++) {
      jp.jasminesoft.jfc.model.jcalendar_lp.Calendaritem[] citems =
        items[i].getCalendaritem();
      if (citems != null) {
        for (int j=0; j<citems.length; j++) {
          String staff = citems[j].getStaff();
          if (staff != null) {		
  		    String[] stokens = staff.split(",");
            if (stokens != null && stokens.length > 0) {
              for (int k=0; k<stokens.length; k++) {
                if (stokens[k].length() > 0 && !stokens[k].endsWith("(-)")) {
                  staffSet.add(stokens[k]);
                }
              }
            }
          }
        }
      }
    }
    return (String[])staffSet.toArray(new String[0]);
  }

/*
 * @deprecated
 * Use 'getDateAsString' method instead of this.
 *
  public final String getDayPart(String s) {
    int length = s.length();
    return s.substring(length-2);
  }
*/
  public final String getYoubiInnerMessageKeyName(int pattern) {
    String youbi = null;
    switch (pattern) {
    case Calendar.SUNDAY : youbi = "__jfc_common.displaycalendar.label.inner.sunday"; break;
    case Calendar.MONDAY : youbi = "__jfc_common.displaycalendar.label.inner.monday"; break;
    case Calendar.TUESDAY : youbi = "__jfc_common.displaycalendar.label.inner.tuesday"; break;
    case Calendar.WEDNESDAY : youbi = "__jfc_common.displaycalendar.label.inner.wednesday"; break;
    case Calendar.THURSDAY : youbi = "__jfc_common.displaycalendar.label.inner.thursday"; break;
    case Calendar.FRIDAY : youbi = "__jfc_common.displaycalendar.label.inner.friday"; break;
    case Calendar.SATURDAY : youbi = "__jfc_common.displaycalendar.label.inner.saturday"; break;
    default : youbi = "";
    }
    return youbi;
  }

  public final String getCssFieldByDate(jp.jasminesoft.jfc.model.jcalendar_lp.Item item, 
                                  int num_of_field,
								  int targetmonth) {
    String __css_field = null;
    String __holiday = item.getHoliday();
    int nowmonth = Integer.parseInt(item.getDate().substring(5,7));

    if (jp.jasminesoft.util.DateTimeUtil.isToday(item.getDate())) {
      __css_field = "schedule_today";
    } else if (nowmonth != targetmonth) {
      __css_field = "schedule_hide";
    } else if (isSunday(item.getDate()) || isHoliday(__holiday)) {
      __css_field = "schedule_sunday";
    } else if (isSaturday(item.getDate())) {
      __css_field = "schedule_saturday";
    } else {
      if (num_of_field % 2 == 0) {
        __css_field = "schedule_normal1";
      } else {
        __css_field = "schedule_normal2";
      }
    }

    return __css_field;
  }

  public final String getYearAsString(jp.jasminesoft.jfc.model.jcalendar_lp.Item item) {
    String year_str = item.getDate().substring(0,4);
    return year_str;
  }

  public final int getYearAsInt(jp.jasminesoft.jfc.model.jcalendar_lp.Item item) {
    String year_str = item.getDate().substring(0,4);
    return Integer.parseInt(year_str);
  }

  public final String getMonthAsString(jp.jasminesoft.jfc.model.jcalendar_lp.Item item) {
    String month_str = item.getDate().substring(5,7);
    month_str = Integer.toString(Integer.valueOf(month_str)); // remove first '0' character.
    return month_str;
  }

  public final int getMonthAsInt(jp.jasminesoft.jfc.model.jcalendar_lp.Item item) {
    String month_str = item.getDate().substring(5,7);
    return Integer.parseInt(month_str);
  }

  public final String getDateAsString(jp.jasminesoft.jfc.model.jcalendar_lp.Item item) {
    String date_str = item.getDate().substring(8,10);
    date_str = Integer.toString(Integer.valueOf(date_str)); // remove first '0' character.
    return date_str;
  }

  public final int getDateAsInt(jp.jasminesoft.jfc.model.jcalendar_lp.Item item) {
    String date_str = item.getDate().substring(8,10);
    return Integer.parseInt(date_str);
  }

  public final String simpleFormat(jp.jasminesoft.jfc.model.jcalendar_lp.Item item, String locale) {
    java.text.SimpleDateFormat df = 
      (java.text.SimpleDateFormat)java.text.DateFormat.getDateTimeInstance();
    String rkey = jp.jasminesoft.jfc.JFCUtils.getRValue("__jfc_common.displaycalendar.format.simple_ymd", locale);
    df.applyPattern(rkey);
    java.util.Date _date = createCalendar(item.getDate()).getTime();
    return df.format(_date);
  }
%>
